	Option Base 0

	Dim Integer TMRctr(9),TMRini(9)
	Dim Integer n,Flags

	'Select Case MM.DEVICE$
	'	Case "Micromite MkII"
	'		FlagSet(63)'62 is the pin count 1=44pin
	'	Case "ARMmite H7"
	'		FlagSet(61)
	'End Select

	n=0: dir=0

	do
		Print unixtime(now()),humantime(unixtime(now())),now(),IsDate(date$),IsTime(time$), DoW(Now())
		'If FlagTest(63)=0 then PORT(PB14,1,PB7,1,PB0,1)= 2^n
	loop


	Sub FlagSet(bit As Integer)
		Flags=Flags Or (2^bit)
	End Sub

	Sub FlagRes(bit As Integer)
		Flags=(Flags Or (2^bit)) Xor (2^bit)
	End Sub

	Function FlagTest(bit As Integer) As Integer
		FlagTest=Abs(Sgn(Flags And (2^bit)))
	End Function


	Function ZPad$(x As integer,y As integer)
		'adds y leading zeros to X
		ZPad$=Right$(String$(y,"0")+Str$(x),y)
	End Function

	Function Split(a$,b$) As Integer' returns the number of dimensions in SP$ always starts from 1 regardless of OPTION BASE
		Local INTEGER z,n,m
		If b$="" Then Split=0:Exit Function ' can't split with an empty delimiter

		' if SP$ doesn't exist, the ERASE will cause an error, choose which ON ERROR SKIP you need

		'MM.Ver <5.04
		'    ON ERROR SKIP    or
		'MM.Ver >=5.04
		On ERROR SKIP 1

		Erase SP$
		z=1:n=0
		Do 'count instances of delimiter for DIM SP$()
			z=Instr(z,a$,b$)
			If z=0 Then
				If n=0 Then ' no delimeters
					Dim SP$(1):SP$(1)=a$:Split=1:Exit Function ' only one substring
				Else
					Exit Do
				End If
			Else
				n=n+1:z=z+Len(b$)
			End If
		Loop
		m=n+1:n=1
		Dim SP$(m)
		Do
			z=Instr(1,a$,b$)
			If z=0 Then
				SP$(m)=a$:Exit Do
			Else
				SP$(n)=Left$(a$,z-1):a$=Mid$(a$,z+Len(b$)):n=n+1
			End If
		Loop
		Split=m
	End Function

	'regexp, case sensitive
	Function RegExp(regex$,text$) ' case sensitive
		Local s,n,m,f
		n=Len(regex$):m=Len(text$)
		RegExp=0
		If Mid$(regex$,1,1)="^" Then
			MatchHere regex$,text$,2,1,n,m,f
			RegExp=f
		Else
			For s=1 To m
				MatchHere regex$,text$,1,s,n,m,f
				If f Then RegExp=s: Exit For
			Next
		EndIf
	End Function

	Sub MatchHere(regex$,text$,r,s,n,m,f)
		Local i
		Do While r <= n
			If Mid$(regex$,r)="$" Then f=s>m: Exit Sub
			If Mid$(regex$,r,1)="[" Then
				i=Instr(r+2,regex$,"]")
				If i Then i=i+1 Else i=r+1
			ElseIf Mid$(regex$,r,1)="\" Then
				i=r+2
				Else
				i=r+1
			EndIf
			If Mid$(regex$,i,1)="*" Then
				MatchStar regex$,text$,r,i,s,n,m,f
				Exit Sub
			EndIf
			If Mid$(regex$,i,1)="?" Then
				MatchOptional regex$,text$,r,i,s,n,m,f
				Exit Sub
			EndIf
			If s>m Then f=0: Exit Sub
			i=r
			MatchChar regex$,text$,r,s,f
			If Not f Then Exit Sub
			If Mid$(regex$,r+1,1)="+" Then
				MatchStar regex$,text$,i,r+1,s+1,n,m,f
				Exit Sub
			EndIf
			r=r+1: s=s+1
		Loop
		f=1
	End Sub

	Sub MatchStar(regex$,text$,r,i,s,n,m,f)
		Do
			MatchHere regex$,text$,i+1,(s),n,m,f
			If f or s>m Then Exit Sub
			MatchChar regex$,text$,(r),s,f
			If Not f Then Exit Sub
			s=s+1
		Loop
	End Sub

	Sub MatchOptional(regex$,text$,r,i,s,n,m,f)
		MatchHere regex$,text$,i+1,(s),n,m,f
		If f or s>m Then Exit Sub
		MatchChar regex$,text$,(r),s,f
		If Not f Then Exit Sub
		MatchHere regex$,text$,i+1,s+1,n,m,f
	End Sub

	Sub MatchChar(regex$,text$,r,s,f)
		Local i,j
		f=Mid$(regex$,r,1)="."
		If f Then Exit Sub
		If Mid$(regex$,r,1)="[" Then
			i=Instr(r+2,regex$,"]")
			If i Then
				j=Instr(r+1,regex$,Mid$(text$,s,1))
				f=j>0 And j<i:r=i
				Exit Sub
			EndIf
		ElseIf Mid$(regex$,r,1)=Chr$(92) Then
			r=r+1
		EndIf
		f=Mid$(regex$,r,1)=Mid$(text$,s,1)
	End Sub

	
	Function Now(opt as Integer) as string
		Local a$

		Do ' ensure the date/time doesn't change while we are processing
			a$=Date$+" "+Time$
			Now=Date$+" "+Time$
		Loop While a$<>Now

		If opt<>0 then
			Now=Mid$(a$,7,4)+Mid$(a$,3,4)+Left$(a$,2)+Mid$(a$,11)
		EndIf
	End Function

	Function DayLight(dt$,opt as integer) As Integer
		'opt = 1, return daytime start, 2, return daytime end anything else return bool of daytime now
		Local Integer mn,st,fn,st0,fn0,dd,mm
		dd=DatePart("dd",dt$):mm=DatePart("mm",dt$)
		Do
			Select Case mm
				Case 1:st=490:fn=960
				Case 2:st=460:fn=1010
				Case 3:st=405:fn=1060
				Case 4:st=335:fn=1115
				Case 5:st=275:fn=1165
				Case 6:st=230:fn=1210
				Case 7:st=230:fn=1220
				Case 8:st=265:fn=1190
				Case 9:st=315:fn=1115
				Case 10:st=360:fn=1060
				Case 11:st=415:fn=990
				Case 12:st=470:fn=955
				Case 13:st=490:fn=960
			End Select
			If fn0<>0 Then Exit Do
			fn0=fn:st0=st
			mm=mm+1
		Loop
		st=st0-(((st0-st)/30)*dd):fn=fn0-(((fn0-fn)/30)*dd)
		Select Case opt
			Case 1
				DayLight=st
			Case 2
				DayLight=fn
			Case Else
				mn=(DatePart("h",dt$)*60)+DatePart("m",dt$)
				DayLight=(mn>=st) And (mn<fn)
		End Select
	End Function

	Function UnixTime(HHT$,opt) As integer
		' seconds since 01-01-1970. no checks on the argument format
		' HT$ is DD-MM-YYYY HH:MM:SS or if opt=1 HT$ is YYYY-MM-DD HH:MM:SS
		' Now() returns a suitable string
		Local integer n,s,y,m
		Local String DD$,TT$,HT$
		HT$=HHT$' preserves the original argument
		? hht$,ht$: exit function
		
		m=Split(HT$," ")
		?m
		If m<>2 Then UnixTime=-1:Exit Function
		DD$=SP$(1):TT$=SP$(2)
		? dd$, tt$
		m=Split(DD$,"-")
		?m
		If m<>3 Then UnixTime=-2:Exit Function
		If opt=0 Then
			y=Val(SP$(3))
		Else
			y=Val(SP$(1))
		EndIf
		s=0
		For n=1970 To y-1
			s=s+365+IsLeapYear(n)
		Next
		For n=1 To Val(SP$(2))-1
			Select Case n
				Case 1,3,5,7,8,10
					s=s+31
				Case 2
					s=s+28+IsLeapYear(y)
				Case 4,6,9,11
					s=s+30
			End Select
		Next
		If opt=0 Then
			s=86400*(s+Val(SP$(1))-1)
		Else
			s=86400*(s+Val(SP$(3))-1)
		EndIf
		m=Split(TT$,":")
		If m<>3 Then UnixTime=-1:Exit Function
		s=s+(3600*Val(SP$(1))) + (60*Val(SP$(2))) + Val(SP$(3))
		UnixTime=s
	End Function

	Function IsLeapYear(n As integer) As integer
		IsLeapYear=((n Mod 4=0) And (n Mod 100 <>0)) Or (n Mod 400=0)
	End Function

	Function HumanTime(UUT As Integer,opt As Integer) As String
		' take seconds since 1970-01-01 (unixtime) and converts to a human form date/time as
		' if opt=0 (or not specified) the format is dd-mm-yyyy hh:mm:ss to match the format of DATE$
		' if opt<>0 the date part is returned as yyyy-mm-dd
		Local integer d,m,s,y,z,UT
		UT=UUT' preserves the original argument
		If UT<0 Then HumanTime$="":Exit Function
		y=1970:d=UT\86400:s=UT Mod 86400
		Do
			z=365+IsLeapYear(y)
			If d>=z Then
				d=d-z:y=y+1
			Else
				Exit Do
			EndIf
		Loop
		'here, Y is the current year and d the remaining days
		m=1' start at january
		' days between the start of the year and the current month
		Do
			z=0
			Select Case m
				Case 1,3,5,7,8,10
					If d>=31 Then d=d-31:z=1
				Case 2
					If IsLeapYear(y)Then
						If d>=29 Then d=d-29:z=1
					Else
						If d>=28 Then d=d-28:z=1
					EndIf
				Case 4,6,9,11
				If d>=30 Then d=d-30:z=1
			End Select
			If z=1 Then
				m=m+1
			Else
				d=d+1:Exit Do 'first day is 1 not 0
			EndIf
		Loop
		If opt<>0 Then
			HumanTime$=Str$(y)+"-"+ZPad$(m,2)+"-"+ZPad$(d,2)
		Else
			HumanTime$=ZPad$(d,2)+"-"+ZPad$(m,2)+"-"+Str$(y)
		EndIf
		y=s\3600:s=s-y*3600
		m=s\60:s=s-m*60
		HumanTime$=HumanTime$+" "+ZPad$(y,2)+":"+ZPad$(m,2)+":"+ZPad$(s,2)
	End Function

	Function DoW(d$) As Integer '0=Sun
		DoW=(4+DateDiff("dd","01-01-1970 00:00:00",d$)) mod 7
	End Function

   	Function DateAdd(Num As Integer,Interval As String,dt As String) As String
		'return a string of the datetime with the relevant period added
		'add -ve to subtract e.g.
		'DateAdd (2,"mm",Now())  returns the datetime time two months from now.
		'DateAdd(-1000,"dd",Now()) returns the datetime a thousand days ago
		Local Integer x,y,z
		Select Case LCase$(Interval)
			Case "s"' Seconds
				DateAdd=HumanTime(UnixTime(dt)+Num)
			Case "m"' Minutes
				DateAdd=HumanTime(UnixTime(dt)+(Num*60))
			Case "h"' Hours
				DateAdd=HumanTime(UnixTime(dt)+(Num*3600))
			Case "dd" 'Days
				DateAdd=HumanTime(UnixTime(dt)+(Num*86400))
			Case "w" 'Weeks
				DateAdd=HumanTime(UnixTime(dt)+(Num*604800))
			Case "mm"' calendar Months
				x=Val(Mid$(dt,4,2))-1: y=Val(Mid$(dt,7,4)): z=Val(Left$(dt,2))
				x=((x+Num) Mod 12)+1: y=y+Num\12
				If (x=2 And z=29) And (Not IsLeapYear(y)) Then ' bludgeon for 29/02 in non-leap year
					x=3:z=1
				EndIf
				DateAdd=ZPad$(z,2)+"-"+ZPad$(Abs(x),2)+"-"+Zpad$(y,4)+ Right$(dt$,9)
			Case "yyyy"' Years
				x=Val(Left$(dt,2)): y=Val(Mid$(dt,4,2)): z=Val(Mid$(dt,7,4)):
				z=z+num
				If (y=2 And x=29) And (Not IsLeapYear(z)) Then ' bludgeon for 29/02 in non-leap year
					y=3:x=1
				EndIf
				DateAdd=ZPad$(x,2)+"-"+ZPad$(Abs(y),2)+"-"+Zpad$(z,4)+ Right$(dt$,9)
			Case Else
				DateAdd=""
		End Select
	End Function

	Function DateDiff(Interval As String,dt1 As String,dt2 As String) As Integer
		'return the number of whole intervals between two dates
		'Result is +ve when DT1<DT2
		'DateDiff ("dd","01/02/2001",Now())  returns the difference in whole days since 1st Feb 2001
		Local Integer n,s,t,u,v,x,y,z
		Select Case LCase$(Interval)
			Case "s"' Seconds
				DateDiff=UnixTime(dt2)-UnixTime(dt1)
			Case "m"' Minutes
				DateDiff=(UnixTime(dt2)-UnixTime(dt1))\60
			Case "h"' Hours
				DateDiff=(UnixTime(dt2)-UnixTime(dt1))\3600
			Case "dd" 'Days
				DateDiff=(UnixTime(dt2)-UnixTime(dt1))\86400
			Case "w" 'Weeks
				DateDiff=(UnixTime(dt2)-UnixTime(dt1))\604800
			Case "mm"' calendar Months
				t=UnixTime(dt1):u=UnixTime(dt2):s=Sgn(u-t)
				If s Then
					dt1=HumanTime(Min(t,u)):dt2=HumanTime(Max(t,u))
					t=Val(Left$(dt1,2)):u=Val(Mid$(dt1,4,2)):v=Val(Mid$(dt1,7,4))
					x=Val(Left$(dt2,2)):y=Val(Mid$(dt2,4,2)):z=Val(Mid$(dt2,7,4))
					for n=v+1 to z
						DateDiff=DateDiff+12
					next
					DateDiff=DateDiff+(y-u)
					If t>x then DateDiff=DateDiff-1
				EndIf
				DateDiff=DateDiff*s
			Case "yyyy"' Years
				t=UnixTime(dt1):u=UnixTime(dt2):s=Sgn(u-t)
				If s Then
					dt1=HumanTime(Min(t,u)):dt2=HumanTime(Max(t,u))
					t=Val(Left$(dt1,2)):u=Val(Mid$(dt1,4,2)):v=Val(Mid$(dt1,7,4))
					x=Val(Left$(dt2,2)):y=Val(Mid$(dt2,4,2)):z=Val(Mid$(dt2,7,4))
					DateDiff=z-v
					If u>y Then
						DateDiff=DateDiff-1
					ElseIf u=y Then
						If t>x Then DateDiff=DateDiff-1
					EndIf
				EndIf
				DateDiff=DateDiff*s
			Case Else
				DateDiff=0
		End Select
	End Function

	Function DatePart(Interval As String,dt As String) As Integer
		Select Case LCase$(Interval)
			Case "s"' Seconds
				DatePart=Val(Right$(dt,2))
			Case "m"' Minutes
				DatePart=Val(Mid$(dt,15,2))
			Case "h"' Hours
				DatePart=Val(Mid$(dt,12,2))
			Case "dd" 'Days
				DatePart=Val(Left$(dt,2))
			Case "mm"' calendar Month
				DatePart=Val(Mid$(dt,4,2))
			Case "yyyy"' Year
				DatePart=Val(Mid$(dt,7,4))
			Case Else
				DatePart=0
		End Select
	End Function

 Function IsTime(t$) As Integer ' times must be hh:mm:ss
	IsTime=0
	If RegExp("^[012][0123456789]:[012345][0123456789]:[012345][0123456789]$",t$) Then
		If Val(Left$(t$,2))<24 Then
			If Val(Mid$(t$,4,2))<60 Then
				If Val(Right$(t$,2))<60 Then
					IsTime=1
				EndIf
			EndIf
		EndIf
	EndIf
 End Function

  Function IsDate(t$,opt As Integer) As Integer
	Local Integer d,m,y
	IsDate=0
	If opt=0 then
		If RegExp("^[0123][0123456789][/|-][01][0123456789][/|-][12][0123456789][0123456789][0123456789]$",t$)=0 Then Exit Function
		d=Val(Left$(t$,2))
		m=Val(Mid$(t$,4,2))
		y=Val(Right$(t$,4))
	Else
		If RegExp("^[12][0123456789][0123456789][0123456789][/|-][01][0123456789][/|-][0123][0123456789]$",t$)=0 Then Exit Function
		d=Val(Right$(t$,2))
		m=Val(Mid$(t$,6,2))
		y=Val(Left$(t$,4))
	EndIf
		
	Select Case m
		Case 1,3,5,7,8,10,12
			if d<1 or d>31 Then Exit Function
		Case 4,6,9,11
			if d<1 or d>30 Then Exit Function
		Case 2
			if d<1 or d>28+IsLeapYear(y) Then Exit Function
		Case Else
			Exit Function
	End Select
	IsDate=1
 End Function


